﻿///////////////////////////////////////////////////////////////////////////
//	Original Contribution and Major Debugging: Nabeel		 //
//	Help Tip Functionality and Debugging: Asif Iqbal (28 March, 2005)//
//	ToolTip Script: Walter Zorn					 //
///////////////////////////////////////////////////////////////////////////

var isIE;
var isGecko;
var isSafari;
var isKonqueror;

var kbNormal=1;
var kbShift=2;		
var kbAlt=3;
var kbCtrl=4;
var kbAltGr=5;
var bToggleFlag=0;
var CurrentKeyboardState=1;

	var currEdit=null;
	var langSel=1;
	var IsUrdu=1;

	var charSpace=String.fromCharCode(32);
	var charEnter=String.fromCharCode(13);
	var charTab=String.fromCharCode(9);
	var charNewLine='\n';
	var charColon=String.fromCharCode(58);
	var charSemiColon=String.fromCharCode(59);
	var charSingleQuote=String.fromCharCode(39);
	var charDoubleQuote=String.fromCharCode(34);
	var charFullStop=String.fromCharCode(46); //(0x06D4);
	var charComma=String.fromCharCode(44);
	var charExclaim=String.fromCharCode(33);
	
	var charPlus=String.fromCharCode(43);
	var charMinus=String.fromCharCode(45);
	var charMul=String.fromCharCode(42);
	var charDiv=String.fromCharCode(47);
	var charPrecent=String.fromCharCode(37);
	var charLeftParen=String.fromCharCode(41);
	var charRightParen=String.fromCharCode(40);
	var charEqual=String.fromCharCode(61);
	var charDecSep=String.fromCharCode(61);
	
var langArray=new Array();

	var codes= new Array();
	codes['a']=0x0627;
	codes['b']=0x0628;
	codes['c']=0x0686;
	codes['d']=0x062F;
	codes['e']=0x0639;
	codes['f']=0x0641;
	codes['g']=0x06AF;
	codes['h']=0x06BE;
	codes['i']=0x06CC;
	codes['j']=0x062C;
	codes['k']=0x06A9;
	codes['l']=0x0644;
	codes['m']=0x0645;
	codes['n']=0x0646;
	codes['o']=0x06C1;
	codes['p']=0x067E;
	codes['q']=0x0642;
	codes['r']=0x0631;
	codes['s']=0x0633;
	codes['t']=0x062A;
	codes['u']=0x0626; // hamza yeh
	codes['v']=0x0637;
	codes['w']=0x0648;
	codes['x']=0x0634;
	codes['y']=0x06D2;
	codes['z']=0x0632;
	
	codes['A']=0x0622;
	codes['B']=0x0628;
	codes['C']=0x062B;
	codes['D']=0x0688;
	codes['E']=0x0651; 
	codes['F']=0x064D; 
	codes['G']=0x063A;
	codes['H']=0x062D;
	codes['I']=0x0670; 
	codes['J']=0x0636;
	codes['K']=0x062E;
	codes['L']=0x0628;
	codes['M']=0x064B; 
	codes['N']=0x06BA;
	codes['O']=0x06C3;
	codes['P']=0x064F; 
	codes['Q']=0x0628;
	codes['R']=0x0691;
	codes['S']=0x0635;
	codes['T']=0x0679;
	codes['U']=0x0621;
	codes['V']=0x0638;
	codes['W']=0x0624;
	codes['X']=0x0698;
	codes['Z']=0x0630;
	
	codes['>']=0x0650; 
	codes['<']=0x064E; 



			
	codes[charSpace]=32; 
	codes[charEnter]=13;
	codes[charColon]=0x061B;
	codes[charSemiColon]=0x061B;
	codes[charSingleQuote]=0x2018;
	codes[charDoubleQuote]=0x201C;
	codes[charFullStop]=0x06D4;
	codes[charComma]=0x060C;
	codes[charExclaim]= 0x0021;
	codes['?']=0x061F;
	codes[':']=58;
	
	codes['[']=0x0654; // hamza above
	codes[']']=0x0655; // hamza below
	codes['~']=0x0653; // mad above
	codes['^']=0x0652; // sukun
	codes['/']=0x002F; // slash
	codes['L']=0x064C; // do paish
	//codes['|']=0x0200C; // ZWNJ
	
	
	codes[charPlus]=0x002B;
	codes[charMinus]=0x002D;
	codes[charMul]=0x00D7;
	codes[charDiv]=0x00F7;
	codes[charPrecent]=0x066A;
	codes[charLeftParen]=0x0028;
	codes[charRightParen]=0x0029;
	codes[charEqual]=0x003D;

		
	codes['0']=0x30;
	codes['1']=0x31;
	codes['2']=0x32;
	codes['3']=0x33;
	codes['4']=0x34;
	codes['5']=0x35;
	codes['6']=0x36;
	codes['7']=0x37;
	codes['8']=0x38;
	codes['9']=0x39;

	// Help stuff
	  var HelpHashTable = new Object();
	  HelpHashTable['ا'] = "a";
	  HelpHashTable['آ'] = "A";
	  HelpHashTable['ب'] = "b";
	  HelpHashTable['پ'] = "p";
	  HelpHashTable['ت'] = "t";
	  HelpHashTable['ٹ'] = "T";
	  HelpHashTable['ث'] = "C";
	  HelpHashTable['ج'] = "j";
	  HelpHashTable['چ'] = "c";
	  HelpHashTable['ح'] = "H";
	  HelpHashTable['خ'] = "K";
	  HelpHashTable['د'] = "d";
	  HelpHashTable['ڈ'] = "D";
	  HelpHashTable['ذ'] = "Z";
	  HelpHashTable['ر'] = "r";
	  HelpHashTable['ڑ'] = "R";
	  HelpHashTable['ز'] = "z";
	  HelpHashTable['ژ'] = "X";
	  HelpHashTable['س'] = "s";
	  HelpHashTable['ش'] = "x";
	  HelpHashTable['ص'] = "S";
	  HelpHashTable['ض'] = "J";
	  HelpHashTable['ط'] = "v";
	  HelpHashTable['ظ'] = "V";
	  HelpHashTable['ع'] = "e";
	  HelpHashTable['غ'] = "G";
	  HelpHashTable['ف'] = "f";
	  HelpHashTable['ک'] = "k";
	  HelpHashTable['ق'] = "q";
	  HelpHashTable['گ'] = "g";
	  HelpHashTable['ل'] = "l";
	  HelpHashTable['م'] = "m";
	  HelpHashTable['ن'] = "n";
	  HelpHashTable['ں'] = "N";
	  HelpHashTable['و'] = "w";
	  HelpHashTable['ؤ'] = "W";
	  HelpHashTable['ھ'] = "h";
	  HelpHashTable['ہ'] = "o";
	  HelpHashTable['ء'] = "U";
	  HelpHashTable['ی'] = "i";
	  HelpHashTable['ي'] = "Y";
	  HelpHashTable['ے'] = "y";
	  HelpHashTable['۔'] = ".";
	  HelpHashTable[String.fromCharCode(0x0651)] = "E";
	  HelpHashTable['،'] = ",";
	  HelpHashTable['ِ'] = ">";
	  HelpHashTable['َ'] = "<";
	  HelpHashTable['ُ'] = "P";
	  HelpHashTable['ٍ'] = "F";
	  HelpHashTable['ً'] = "M";
	  HelpHashTable['ئ'] = "u";
	  HelpHashTable['ٰ'] = "I";
	  HelpHashTable['؟'] = "?";

	var Diacritics='[]{}~';
	
	function isDiacritic(sChar)
	{
		if(Diacritics.indexOf(sChar)>=0)
		{
			return true;
		}
		return false;	
	}

	

     function storeCaret (textEl) {
       if (textEl.createTextRange) 
         textEl.caretPos = document.selection.createRange().duplicate();
     }

	function AddText(text) 
	{
	
		if(!currEdit) return;
	 
		if (currEdit.createTextRange && currEdit.caretPos) {      
			var caretPos = currEdit.caretPos;      
			caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ?
			text + ' ' : text;
			currEdit.focus(caretPos);
		}
		else if (currEdit.selectionStart || currEdit.selectionStart == '0') 
		{ 
			var vTop=currEdit.scrollTop;
			//alert(vTop);
			var startPos = currEdit.selectionStart; 
			var endPos = currEdit.selectionEnd; 
			currEdit.value = currEdit.value.substring(0, startPos) 
						  + text 
						  + currEdit.value.substring(endPos, currEdit.value.length); 
			currEdit.focus(); 
			currEdit.selectionStart = startPos + 1; 
			currEdit.selectionEnd = startPos + 1; 
			currEdit.scrollTop=vTop;
		}
		else 
		{
			currEdit.value += text;
			currEdit.focus(caretPos);	
		}
    } 
	
function processKeyup(evt)
{
	if (!currEdit) return;
	evt = (evt) ? evt : ((event) ? event : null);
    if (evt) 
	{
		var charCode = (evt.charCode) ? evt.charCode : evt.keyCode;
		
		if(charCode == 17)
		{
			CurrentKeyboardState = kbNormal;
		}
		else if(charCode == 16)
		{
			CurrentKeyboardState = kbNormal;
		}
	}
}

function processKeydown(evt)
{
	
	//if (!langArray[currEdit.id]) return;
	if (!currEdit) return;
	evt = (evt) ? evt : ((event) ? event : null);
    if (evt) 
	{
		var charCode = (evt.charCode) ? evt.charCode : evt.keyCode;		
		var idxChar=String.fromCharCode(charCode).toLowerCase();
		/*if(charCode != 17)
				alert(CurrentKeyboardState);*/
		if(charCode == 17)
		{
			CurrentKeyboardState = kbCtrl;
		}
		else if(charCode == 16)
		{
			CurrentKeyboardState = kbShift;
		}
		else if(CurrentKeyboardState == kbCtrl)
		{
			/*if(charCode != 17)
				alert(charCode);*/
			if(charCode==32)
			{
				if(langArray[currEdit.id]==1)
				{
					//alert('setting English');
					setEnglish(currEdit.id);
				}
				else
				{
					//alert('setting Urdu');
					setUrdu(currEdit.id);
				}
				if(isIE)
				{
					evt.returnValue=false;
					evt.cancelBubble=true;
				}
				else if(isGecko)
				{
					evt.preventDefault();
					evt.stopPropagation();
				}
			}						
		}
		else if(CurrentKeyboardState == kbShift)
		{
			if(charCode==32)
			{
				if(langArray[currEdit.id]==1)
				{
					//alert("zwnj");
					AddText(String.fromCharCode(0x200C)); //ZWNJ
					if(isIE)
					{
						evt.returnValue=false;
						evt.cancelBubble=true;
					}
					else if(isGecko)
					{
						evt.preventDefault();
						evt.stopPropagation();
					}
				}				
			}
		}
	}
}	

function Downkeys(evt)
{
	if (!langArray[currEdit.id]) return;	     
	evt = (evt) ? evt : (window.event) ? event : null;

	if(evt)
	{
		if(evt.ctrlKey)
		{
			CurrentKeyboardState=kbCtrl;
		}
		else if(evt.shiftKey )
		{
			CurrentKeyboardState=kbShift;
		}
	}	
}

function Upkeys(evt)
{
	evt = (evt) ? evt : (window.event) ? event : null;
	
	if(CurrentKeyboardState == kbCtrl)
	{
		if(!evt.ctrlKey)
		{			
			CurrentKeyboardState = kbNormal;
			//alert(CurrentKeyboardState)
		}
	}	
	
	if(CurrentKeyboardState == kbShift)
	{
		if(!evt.shiftKey)
		{
			CurrentKeyboardState = kbNormal;
		}
	}
}

	function processKeypresses(evt)
	{

		 //alert(currEdit.id);
		 if (!langArray[currEdit.id]) return;
	     
	     evt = (evt) ? evt : (window.event) ? event : null;
		 //if(!evt) evt=window.event;
	     if (evt)
  	      {
		  var charCode = (evt.charCode) ? evt.charCode :
                    ((evt.keyCode) ? evt.keyCode :
                   ((evt.which) ? evt.which : 0));
                   var whichASC = charCode ; // key's ASCII code
			var whichChar = String.fromCharCode(whichASC); // key's character

			
			if(evt.keyCode)
			{
				evt.keyCode= codes[whichChar];
			}
			else if(evt.which)
			{
				//evt.which= codes[whichChar];
				//alert('evt.which : '+whichChar);
				if((CurrentKeyboardState == kbShift) || CurrentKeyboardState == kbCtrl) 
				{
					if(charCode==32)
					{
						evt.preventDefault();
						evt.stopPropagation();
						return;
					}
				}
											
				if(isDiacritic(whichChar)) // fix for the AltGr key on German keyboard
				{
					//alert('isDiacritic : '+charCode);
					AddText( String.fromCharCode(codes[whichChar]));
					evt.preventDefault();
					evt.stopPropagation();	
					return;
				}
				
				if(!(CurrentKeyboardState == kbCtrl))
				{					
					//alert('in : '+charCode);
					AddText( String.fromCharCode(codes[whichChar]));
					evt.preventDefault();
					evt.stopPropagation();					
				}
				
								
			}
			else if(evt.charCode)
			{
				//evt.charCode= codes[whichChar];
				//alert('evt.charCode : '+whichChar);
				AddText(whichChar);
				evt.preventDefault();
				evt.stopPropagation();				
			}			
		  }					 
	}
	
function writeButton(caption, str)
	{
			document.writeln('<td class="btnFlat"  width=6% onclick="javascript:AddText(\''+ str+ '\' );" onmouseover="return escape(\'Keyboard: \'+HelpHashTable[\''+ str+ '\']);" >'+caption+'</td>');

	}
	
function writeButton2(caption, str)
{
			document.writeln('<td class="btnFlat" onclick="javascript:AddText(\''+ str+ '\' );" onmouseover="return escape(\'Keyboard: \'+HelpHashTable[\''+ str+ '\']);" >'+caption+'</td>');
}

function writeKeyboard()
{
	 document.writeln('<span dir="ltr">');
	 document.writeln('<table   width="100%" style="border: 1px solid #C0C0C0;">');

	 //start of keyboard	 
	 document.writeln('<tr>');
		writeButton('ر', 'ر' );
		 writeButton('ذ', 'ذ');
		writeButton('ڈ', 'ڈ' );
		 writeButton('د', 'د');
		 writeButton('خ', 'خ');
		writeButton('ح', 'ح');
		 writeButton('چ', 'چ' );
		 writeButton('ج', 'ج' );
		writeButton('ث', 'ث') ;
		 writeButton('ٹ', 'ٹ' );
		 writeButton('ت', 'ت' );
		 writeButton('پ', 'پ' );
		writeButton('ب', 'ب');
		 writeButton('آ', 'آ' );
		 writeButton('ا', 'ا' );	     
	 document.writeln('</tr><tr>');
		writeButton('گ', 'گ');
		 writeButton('ک', 'ک' );
		writeButton('ق', 'ق' );
		 writeButton('ف', 'ف' );
		writeButton('غ', 'غ' );
		 writeButton('ع', 'ع' );
		writeButton('ظ', 'ظ' );
		 writeButton('ط', 'ط' );
		 writeButton('ض', 'ض' );
		writeButton('ص', 'ص' );
		 writeButton('ش', 'ش' );
		 writeButton('س', 'س');
		writeButton('ژ', 'ژ' );
	 writeButton('ز', 'ز');
	 writeButton('ڑ', 'ڑ');
	document.writeln('</tr>');
	document.writeln('<tr>');
	document.writeln('<TD >&nbsp;</TD >');
		writeButton('؟', '؟');
		writeButton('۔', '۔');
		 writeButton('ے', 'ے');
		 writeButton('ی', 'ی');
		writeButton('ئ', 'ئ');
		 writeButton('ء', 'ء');
		 writeButton('ھ', 'ھ');
		writeButton('ہ', 'ہ');
		 writeButton('ؤ', 'ؤ');
		 writeButton('و', 'و');
		writeButton('ں', 'ں');
		writeButton('ن', 'ن');
		 writeButton('م', 'م');
		 writeButton('ل', 'ل');
	 document.writeln('</tr>');	
	 document.writeln('<tr>');		 
	 //last row for the diacritics
	 document.writeln('<td width="100%" colspan="15">');
	 document.writeln('<table align=right style="border: 1px solid #D3D3D3;" colspan="15">'); 
	document.writeln('<tr>');
	 	//writeButton2('  \"  ',String.fromCharCode(0x0022));
		writeButton2( 'کوما',String.fromCharCode(0x060C));
		 writeButton2( 'تشدید' ,String.fromCharCode(0x0651));
		 writeButton2( 'کھڑی زبر' , String.fromCharCode(0x0670));
		writeButton2( 'درمیانی حمزہ' ,String.fromCharCode(0x0626));
		 writeButton2( 'دو زیر' ,String.fromCharCode(0x064D));
		 writeButton2( 'دو زبر' ,String.fromCharCode(0x064B));
		writeButton2( ' پیش ' ,String.fromCharCode(0x064F));
		 writeButton2( 'زبر' , String.fromCharCode(0x064E));
		 writeButton2( 'زیر' ,String.fromCharCode(0x0650));
	document.writeln('</tr>');   
	document.writeln('</table>');
	//last row
	 document.writeln('</td>');
         	 document.writeln('</tr>');
	 document.writeln('</table>');
	 document.writeln('</span>');
	
	
}

function raiseButton(evt) {
	//IE-Only Function
	evt = (evt) ? evt : (window.event) ? event : null;
	
	if(evt.srcElement)
	{
		var el = evt.srcElement;
		
		className = el.className;
		if (className == 'btnFlat' || className == 'btnLowered') {
			el.className = 'btnRaised';
		}
	}
	else if(evt.target)
	{
		var el = evt.target;
		
		className = el.className;
		if (className == 'btnFlat' || className == 'btnLowered') {
			el.className = 'btnRaised';
		}
	}
}

function normalButton(evt) {
	//IE-Only Function
	evt = (evt) ? evt : (window.event) ? event : null;
	
	if(evt.srcElement)
	{

		var el = window.event.srcElement;
		
		className = el.className;
		if (className == 'btnRaised' || className == 'btnLowered') {
			el.className = 'btnFlat';
		}
	}
	else if(evt.target)
	{
		var el = evt.target;
		
		className = el.className;
		if (className == 'btnRaised' || className == 'btnLowered') {
			el.className = 'btnFlat';
		}
	}
}

function lowerButton(evt) {
	//IE-Only Function
	evt = (evt) ? evt : (window.event) ? event : null;
	
	if(evt.srcElement)
	{
		var el = window.event.srcElement;
		
		className = el.className;
		if (className == 'btnFlat' || className == 'btnRaised') {
			el.className = 'btnLowered';
		}
		
	}
	else if(evt.target)
	{
		var el = evt.target;
		
		className = el.className;
		if (className == 'btnFlat' || className == 'btnRaised') {
			el.className = 'btnLowered';
		}
	}
}
		
		
function addEvent(obj, evType, fn){
	
  if (obj.addEventListener)
  {
    obj.addEventListener(evType, fn, true);
    return true;
  }
  else if (obj.attachEvent)
  {
	  //alert("on"+evType);
    var r = obj.attachEvent("on"+evType, fn);	
    return r;
	
  }
  else
  {
    alert("Handler could not be attached");
  }
}

function setEditor(el)
{
	//alert(el.id);
	currEdit=el;
}

function setUrdu(idx)
{
	langArray[idx]=1;
	var el=document.getElementById(idx);
	el.focus(1);
	el.style.backgroundColor="#99FF99";
	if (el.createTextRange) 
	{
		var caretPos = el.caretPos;
		el.focus(caretPos);
		currEdit=el;
	}
	else if (el.selectionStart || el.selectionStart == '0')
	{
		var startPos = el.selectionStart; 
		el.focus(); 
		currEdit=el;
		el.selectionStart = startPos + 1; 
		el.selectionEnd = startPos + 1;
	}
}

function setEnglish(idx)
{

	langArray[idx]=0;
	var el=document.getElementById(idx);
	el.style.backgroundColor="#CCCCFF";
	if (el.createTextRange && el.caretPos) 
	{
		var caretPos = el.caretPos;
		el.focus(caretPos);
		currEdit=el;
	}
	else if (el.selectionStart || el.selectionStart == '0')
	{
		var startPos = el.selectionStart; 
		el.focus(); 
		currEdit=el;
		el.selectionStart = startPos + 1; 
		el.selectionEnd = startPos + 1;
	}
}

function makeUrduEditor(idx, pt)
{
	langArray[idx]=1;
	var el=document.getElementById(idx);	

	el.lang="ur";
	el.dir="rtl";
	el.onFocus= "setEditor(el)";
	el.onclick="storeCaret(el)";
	el.onkeyup="storeCaret(el)";

	el.wrap="soft";
	with(el.style)
	{
		fontFamily="Urdu Naskh Asiatype";
		fontSize=pt;
		backgroundColor="#99FF99";
	}
	
	addEvent(el , "keypress",  processKeypresses);
	addEvent(el , "keydown",  processKeydown);
	addEvent(el , "keyup",  processKeyup);
}

function CutToClipboard()
{
   CutTxt = currEdit.selection.createRange();
   CutTxt.execCommand("Cut");
} 

function CopyToClipboard()
{
   CopiedTxt = currEdit.selection.createRange();
   CopiedTxt.execCommand("Copy");
}

function PasteFromClipboard()
{ 
   currEdit.focus();
   PastedText = currEdit.createTextRange();
   PastedText.execCommand("Paste");
}

function biggerFont(idx)
{
	var el=document.getElementById(idx);
	
	if (el.style.fontSize == '')
				el.style.fontSize = '1em';
	
	el.style.fontSize = (parseFloat(el.style.fontSize) +1) + "px";
}

function smallerFont(idx)
{
	var el=document.getElementById(idx);

	if (el.style.fontSize == '')
				el.style.fontSize = '1em';
				
	if ((parseFloat(el.style.fontSize) - 0.1) > 0.5)			
				el.style.fontSize = (parseFloat(el.style.fontSize) - 1) + "px";
}

function writeUrduEditor(sName, rows, cols, pt)
{
	if(rows>1)
		document.writeln('<TEXTAREA NAME="'+sName+'" id="'+sName+'" ROWS="'+rows+'" COLS="'+cols+'" style="font-family:Urdu Naskh Asiatype; font-size:'+pt+'; "  onFocus= "setEditor(this)"></TEXTAREA>');	
	else
		document.writeln('<input type="text" name="'+sName+'" id="'+sName+'" size="'+cols+'" style="font-family:Urdu Naskh Asiatype; font-size:'+pt+'; background-color: #FFFF99" lang="ur" dir="rtl"  onfocus="setEditor(this)">');
	var el=document.getElementById(sName);
	langArray[sName]=1;
	/*if(!document.all)
	{
		addEvent(el , "keypress",  processKeypresses);
		//addEvent(el , "keydown",  processKeydown);
	}*/
	el.lang="ur";
	el.dir="rtl";
	el.onFocus= "setEditor(el)";
	el.onclick="storeCaret(el)";
	el.onkeyup="storeCaret(el)";

	el.wrap="soft";
	with(el.style)
	{
		fontFamily="Urdu Naskh Asiatype";
		fontSize=pt;
		backgroundColor="#99FF99";
	}
	
	addEvent(el , "keypress",  processKeypresses);
	addEvent(el , "keydown",  processKeydown);
	addEvent(el , "keyup",  processKeyup);
}

function setFont(idx, fontName)
{
	var el=document.getElementById(idx);	
	with(el.style)
	{
		fontFamily=fontName;
	}
}

function AddEditor(sName)
{
	langArray[sName]=1;
}

function initUrduEditor(cssPath)
{
	
	var ua = navigator.userAgent.toLowerCase();
	isIE = ((ua.indexOf("msie") != -1) && (ua.indexOf("opera") == -1) && (ua.indexOf("webtv") == -1)); 
	isGecko = (ua.indexOf("gecko") != -1);
	isSafari = (ua.indexOf("safari") != -1);
	isKonqueror = (ua.indexOf("konqueror") != -1);
	
	//addEvent(document, "keydown", Downkeys);
	//addEvent(document, "keyup", Upkeys);
	
	//if (isIE) {
		document.onmouseover = raiseButton;
		document.onmouseout  = normalButton;
		document.onmousedown = lowerButton;
		document.onmouseup   = raiseButton;
	//}
	
	var sPath='';
	if(arguments.length>0) sPath=cssPath;
	document.writeln('<style type="text/css">@import"' + sPath + 'UrduEditor.css";</style>');
}